  DEFINT A-Z
  CONST Num$ = "0123456789"
  ON ERROR GOTO Oops
  VIEW PRINT
  COLOR 14
  CLS
  LOCATE 1, 25, 1
  COLOR 9, 0
  PRINT "FILE TO BMP <> BMP TO FILE";
  VIEW PRINT 3 TO 24
  COLOR 14
  CLS
  PRINT "<F>";
  COLOR 2
  PRINT "ile To BMP or ";
  COLOR 14
  PRINT "<B>";
  COLOR 2
  PRINT "MP To File: ";
  COLOR 14
  DO
    An$ = UCASE$(INKEY$)
    IF LEN(An$) THEN
      IF An$ = CHR$(13) THEN
        VIEW PRINT
        COLOR 7, 0
        CLS
        SYSTEM
      ELSEIF INSTR("BF", An$) THEN
        EXIT DO
      END IF
    END IF
  LOOP
  PRINT "<"; An$; ">";
  IF An$ = "B" THEN
    GOTO ExistingBMP
  END IF

ExistingFile:
  VIEW PRINT 5 TO 24
  COLOR 14
  CLS
  COLOR 2
  PRINT "EXISTING File Name: ";
  COLOR 14
  LINE INPUT ; FileName$
  FileName$ = LTRIM$(RTRIM$(UCASE$(FileName$)))
  IF FileName$ = "" THEN
    RUN
  ELSEIF LEN(DIR$(FileName$)) = 0 THEN
    Exists = 0
    GOSUB ExistsOrNot
    GOTO ExistingFile
  END IF
                                                     ' Open the Existing File
  FileName = FREEFILE
  OPEN FileName$ FOR BINARY AS #FileName LEN = 1
  FileNameSize& = LOF(FileName)
  PRINT TAB(69);
  COLOR 15
  Format$ = STRING$(LEN(STR$(FileNameSize&)), "#") + ","
  IF FileNameSize& < 10 THEN
    Format$ = LEFT$(Format$, 1)
  ELSEIF FileNameSize& < 100 THEN
    Format$ = LEFT$(Format$, 2)
  ELSEIF FileNameSize& < 1000 THEN
    Format$ = MID$(Format$, 3)
  ELSEIF FileNameSize& < 1000000 THEN
    Format$ = MID$(Format$, 2)
  END IF
  PRINT "(";
  PRINT USING Format$; FileNameSize&;      ' Format FileNameSize& with Commas
  PRINT ")";

NewBMP:
  VIEW PRINT 7 TO 24
  COLOR 14
  CLS
  COLOR 2
  PRINT "NEW BMP File [FileName.BMP]: ";
  COLOR 14
  LINE INPUT ; BMPFile$
  BMPFile$ = LTRIM$(RTRIM$(UCASE$(BMPFile$)))
  IF BMPFile$ = "" THEN
    CLOSE
    GOTO ExistingFile
  ELSEIF RIGHT$(BMPFile$, 4) <> ".BMP" THEN
    GOTO NewBMP
  ELSEIF LEN(DIR$(BMPFile$)) THEN
    Exists = -1
    GOSUB ExistsOrNot
    GOTO NewBMP
  END IF

AspectOrFixedX:
  VIEW PRINT 9 TO 24
  COLOR 14
  CLS
  PRINT "<A>";
  COLOR 2
  PRINT "spect Ratio (Y/X) or ";
  COLOR 14
  PRINT "<F>";
  COLOR 2
  PRINT "ixed X-Value (Divisible by 4): ";
  DO
    How$ = UCASE$(INKEY$)
    IF LEN(How$) THEN
      IF How$ = CHR$(13) THEN
        GOTO NewBMP
      ELSEIF INSTR("AF", How$) THEN
        EXIT DO
      END IF
    END IF
  LOOP
  COLOR 14
  PRINT "<"; How$; ">";
  IF How$ = "A" THEN
    GOSUB Aspect
    IF Aspect$ = "" THEN
      GOTO AspectOrFixedX
    END IF
  ELSE GOSUB FixedX
    IF BMPWidth$ = "" THEN
      GOTO AspectOrFixedX
    END IF
  END IF

  BMPFile = FREEFILE                                  ' Open the NEW BMP File
  OPEN BMPFile$ FOR BINARY AS #BMPFile LEN = 1
  BMPByte$ = "B"
  PUT BMPFile, , BMPByte$
  BMPByte$ = "M"                                              '"BM" Signature
  PUT BMPFile, , BMPByte$
  FOR X = 1 TO 4
    BMPByte$ = MID$(BMPLength$, X, 1)
    PUT BMPFile, , BMPByte$                                       ' File Size
  NEXT X
  BMPByte$ = CHR$(0)
  FOR X = 1 TO 4
    PUT BMPFile, , BMPByte$                                        ' Reserved
  NEXT X
  FOR X = 1 TO 4
    BMPByte$ = MID$(Header$, X, 1)                    ' Offset to Raster Data
    PUT BMPFile, , BMPByte$
  NEXT X
  Data$ = MKL$(40)
  FOR X = 1 TO 4
    BMPByte$ = MID$(Data$, X, 1)                      ' Info Header Size = 40
    PUT BMPFile, , BMPByte$
  NEXT X
  FOR X = 1 TO 4
    BMPByte$ = MID$(BMPWidth$, X, 1)                              ' BMP Width
    PUT BMPFile, , BMPByte$
  NEXT X
  FOR X = 1 TO 4
    BMPByte$ = MID$(BMPHeight$, X, 1)                            ' BMP Height
    PUT BMPFile, , BMPByte$
  NEXT X
  Data$ = MKI$(1)
  FOR X = 1 TO 2
    BMPByte$ = MID$(Data$, X, 1)                       ' Number of Planes = 1
    PUT BMPFile, , BMPByte$
  NEXT X
  Data$ = MKI$(8)
  FOR X = 1 TO 2
    BMPByte$ = MID$(Data$, X, 1)               ' 8-bit palletized, 256 Colors
    PUT BMPFile, , BMPByte$
  NEXT X
  BMPByte$ = CHR$(0)
  FOR X = 1 TO 8
    PUT BMPFile, , BMPByte$                 ' Compression & Size of Image = 0
  NEXT X                   ' Size of Image = 0 is valid since Compression = 0
  FOR X = 1 TO 8
    PUT BMPFile, , BMPByte$  ' Horizontal & Vertical Resolution NOT necessary
  NEXT X
  Data$ = MKL$(256)
  FOR X = 1 TO 4
    BMPByte$ = MID$(Data$, X, 1)                ' Number of Used Colors = 256
    PUT BMPFile, , BMPByte$
  NEXT X
  BMPByte$ = CHR$(0)
  FOR X = 1 TO 4
    PUT BMPFile, , BMPByte$            ' Number of Important Colors (0 = all)
  NEXT X

WhatPalette:
  Char0$ = CHR$(0)
  VIEW PRINT 13 TO 24
  COLOR 14
  CLS
  LOCATE 13, 1, 1
  PRINT "<S>";
  COLOR 2
  PRINT "olid or ";
  COLOR 14
  PRINT "<R>";
  COLOR 2
  PRINT "andom Palette: ";
  DO
    Choice$ = UCASE$(INKEY$)
    IF LEN(Choice$) THEN
      IF Choice$ = CHR$(13) THEN
        CLOSE BMPFile
        KILL BMPFile$
        GOTO AspectOrFixedX
      ELSEIF INSTR("SR", Choice$) THEN
        EXIT DO
      END IF
    END IF
  LOOP
  COLOR 14
  PRINT "<"; Choice$; ">";
  IF Choice$ = "S" THEN
    GOSUB SolidPalette
    IF Red$ = "" THEN
      GOTO WhatPalette
    END IF
  ELSEIF Choice$ = "R" THEN
    GOSUB RandomPalette
  END IF
  Data$ = SPACE$(1)
  FOR X = 1 TO 2
    Data$ = MID$(Slag$, X, 1) ' Put Slag$ into the first 2-bytes of Data Area
    PUT BMPFile, , Data$
  NEXT X
  FOR X& = 1 TO FileNameSize&
    GET FileName, , Data$
    PUT BMPFile, , Data$
  NEXT X&
 FOR X = 1 TO Slag
    RandomRGB = INT(256 * RND)
    BMPByte$ = CHR$(RandomRGB)
    PUT BMPFile, , BMPByte$
  NEXT X
  CLOSE
  RUN                                                                 ' DONE!

ExistingBMP:
  VIEW PRINT 9 TO 24
  COLOR 14
  CLS
  COLOR 2
  PRINT "EXISTING BMP File [FileName.BMP]: ";
  COLOR 14
  LINE INPUT ; BMPFile$
  BMPFile$ = LTRIM$(RTRIM$(UCASE$(BMPFile$)))
  IF BMPFile$ = "" THEN
    RUN
  ELSEIF RIGHT$(BMPFile$, 4) <> ".BMP" THEN
    GOTO ExistingBMP
  ELSEIF LEN(DIR$(BMPFile$)) = 0 THEN
    Exists = 0
    GOSUB ExistsOrNot
    GOTO ExistingBMP
  END IF

NewFile:
  VIEW PRINT 12 TO 24
  COLOR 14
  CLS
  COLOR 2
  PRINT "NEW File Name: ";
  COLOR 14
  LINE INPUT ; FileName$
  FileName$ = LTRIM$(RTRIM$(UCASE$(FileName$)))
  IF FileName$ = "" THEN
    GOTO ExistingBMP
  ELSEIF LEN(DIR$(FileName$)) THEN
    Exists = -1
    GOSUB ExistsOrNot
    GOTO NewFile
  END IF
  GOSUB Working
  BMPFile = FREEFILE
  OPEN BMPFile$ FOR BINARY AS #BMPFile LEN = 1
  SEEK BMPFile, 1079        ' Right after the header (beginning of data area)
  BMPByte$ = SPACE$(1)
  FOR X = 1 TO 2
    GET BMPFile, , BMPByte$
    Slag$ = Slag$ + BMPByte$
  NEXT X
  Slag = CVI(Slag$)                  ' Slag length stored as a 2-byte integer
  FileNameSize& = LOF(BMPFile) - 1080 - Slag
  FileName = FREEFILE
  OPEN FileName$ FOR BINARY AS #FileName LEN = 1
  FOR X& = 1 TO FileNameSize&
    GET BMPFile, , BMPByte$
    PUT FileName, , BMPByte$
  NEXT X&
  CLOSE
  RUN                                                                 ' DONE!

ExistsOrNot:                                                     ' Subroutine
  COLOR 15
  LOCATE 24, 30, 0
  PRINT "File ";
  IF Exists THEN
    PRINT "ALREADY ";
  ELSE
    PRINT "DOES NOT ";
  END IF
  PRINT "Exist";
  IF Exists THEN
    PRINT "s";
    Exists = 0
  END IF
  PRINT "!";
  WHILE INKEY$ = ""
  WEND
  RETURN

Aspect:                                                          ' Subroutine
  VIEW PRINT 11 TO 24
  COLOR 14
  CLS
  COLOR 2
  PRINT "Aspect Ratio (Y/X, To 7-Digits Plus Decimal): ";    ' Single Presion
  COLOR 14
  LINE INPUT ; Aspect$
  Aspect$ = LTRIM$(RTRIM$(Aspect$))
  IF Aspect$ = "" THEN
    RETURN
  ELSEIF LEFT$(Aspect$, 1) = "0" THEN
    GOTO Aspect
  ELSEIF LEN(Aspect$) > 8 THEN
    GOTO Aspect
  END IF
  Decimal = INSTR(Aspect$, ".")
  FOR X = 1 TO Decimal - 1
    IF INSTR(Num$, MID$(Aspect$, X, 1)) = 0 THEN
      GOTO Aspect
    END IF
  NEXT X
  FOR X = Decimal + 1 TO LEN(Aspect$)
    IF INSTR(Num$, MID$(Aspect$, X, 1)) = 0 THEN
      GOTO Aspect
    END IF
  NEXT X
  Aspect! = VAL(Aspect$)
  GOSUB Math
  RETURN

FixedX:                                                          ' Subroutine
  VIEW PRINT 11 TO 24
  COLOR 14
  CLS
  COLOR 2
  PRINT "X-Pixels (MUST BE Divisible By FOUR): ";
  COLOR 14
  LINE INPUT ; BMPWidth$
  BMPWidth$ = LTRIM$(RTRIM$(BMPWidth$))
  IF BMPWidth$ = "" THEN
    RETURN
  ELSEIF LEFT$(BMPWidth$, 1) = "0" THEN
    GOTO FixedX
  ELSEIF VAL(BMPWidth$) / 4 <> VAL(BMPWidth$) \ 4 THEN
    GOTO FixedX
  END IF
  FOR X = 1 TO LEN(BMPWidth$)
    IF INSTR(Num$, MID$(BMPWidth$, X, 1)) = 0 THEN
      GOTO FixedX
    END IF
  NEXT X
  BMPWidth& = VAL(BMPWidth$)
  GOSUB Math
RETURN

Math:                                                            ' Subroutine
  IF How$ = "F" THEN
    GOTO Bypass           ' For Fixed BMP Width, BMPWidth& Is Already Defined
  END IF
  Data1& = FIX(SQR((FileNameSize& + 2) / Aspect!)) ' + 2 = MKI$(Slag Overage)
  Data2& = Data1& \ 4
  IF Data2& = 0 THEN                                  ' If FileNameSize& < 14
    Data2& = Data2& + 1
  END IF
  BMPWidth& = 4 * Data2&                   ' BMP Width MUST BE Divisible By 4
Bypass:
  BMPWidth$ = MKL$(BMPWidth&)
  BMPHeight& = FileNameSize& / BMPWidth&
  Data3# = FileNameSize& + 2
  Data4# = BMPWidth&
  IF Data3# / Data4# <> FIX(Data3# / Data4#) THEN
    BMPHeight& = BMPHeight& + 1       ' So that you get ALL the Existing File
  END IF
  BMPHeight$ = MKL$(BMPHeight&)
  PRINT TAB(65);
  COLOR 15
  PRINT "("; BMPWidth&; "x"; BMPHeight&; ")";
  Slag = (BMPWidth& * BMPHeight&) - FileNameSize& - 2  ' Just "Filler" Amount
  Slag$ = MKI$(Slag)
  Header& = 1078
  Header$ = MKL$(Header&)
  BMPLength& = (BMPWidth& * BMPHeight&) + Header&
  BMPLength$ = MKL$(BMPLength&)
  RETURN

RandomPalette:                                                   ' Subroutine
  GOSUB Working
  RANDOMIZE TIMER
  FOR X = 1 TO 256
    FOR Y = 1 TO 3
      RandomRGB = INT(256 * RND)
      BMPByte$ = CHR$(RandomRGB)
      PUT BMPFile, , BMPByte$
    NEXT Y
    PUT BMPFile, , Char0$                     ' Pad before next palette color
  NEXT X
  RETURN

SolidPalette:                                                    ' Subroutine
  VIEW PRINT 15 TO 24
  COLOR 14
  CLS
  COLOR 2
  PRINT "Shade of RED (0 to 255): ";
  COLOR 14
  LINE INPUT ; Red$
  Red$ = LTRIM$(RTRIM$(Red$))
  IF Red$ = "" THEN
    RETURN
  ELSEIF LEFT$(Red$, 1) = "0" AND LEN(Red$) > 1 THEN
    GOTO SolidPalette
  ELSEIF LEN(Red$) > 3 THEN
    GOTO SolidPalette
  END IF
  FOR X = 1 TO LEN(Red$)
    IF INSTR(Num$, MID$(Red$, X, 1)) = 0 THEN
      GOTO SolidPalette
    END IF
  NEXT X
  IF VAL(Red$) > 255 THEN
    GOTO SolidPalette
  END IF
  Red$ = CHR$(VAL(Red$))
Green:
  VIEW PRINT 17 TO 24
  COLOR 14
  CLS
  COLOR 2
  PRINT "Shade of GRN (0 to 255): ";
  COLOR 14
  LINE INPUT ; Green$
  Green$ = LTRIM$(RTRIM$(Green$))
  IF Green$ = "" THEN
    GOTO SolidPalette
  ELSEIF LEFT$(Green$, 1) = "0" AND LEN(Green$) > 1 THEN
    GOTO Green
  ELSEIF LEN(Green$) > 3 THEN
    GOTO Green
  END IF
  FOR X = 1 TO LEN(Green$)
    IF INSTR(Num$, MID$(Green$, X, 1)) = 0 THEN
      GOTO Green
    END IF
  NEXT X
  IF VAL(Green$) > 255 THEN
    GOTO Green
  END IF
  Green$ = CHR$(VAL(Green$))
Blue:
  VIEW PRINT 19 TO 24
  COLOR 14
  CLS
  COLOR 2
  PRINT "Shade of BLU (0 to 255): ";
  COLOR 14
  LINE INPUT ; Blue$
  IF Blue$ = "" THEN
    GOTO Green
  ELSEIF LEFT$(Blue$, 1) = "0" AND LEN(Blue$) > 1 THEN
    GOTO Blue
  ELSEIF LEN(Blue$) > 3 THEN
    GOTO Blue
  END IF
  FOR X = 1 TO LEN(Blue$)
    IF INSTR(Num$, MID$(Blue$, X, 1)) = 0 THEN
      GOTO Blue
    END IF
  NEXT X
  IF VAL(Blue$) > 255 THEN
    GOTO Blue
  END IF
  Blue$ = CHR$(VAL(Blue$))
  GOSUB Working
  SEEK BMPFile, 55
  FOR X = 1 TO 256
    PUT BMPFile, , Blue$         ' Store in LSB/MSB format (Blue, Green, Red)
    PUT BMPFile, , Green$
    PUT BMPFile, , Red$
    PUT BMPFile, , Char0$                     ' Pad before next palette color
  NEXT X
  RETURN

Working:                                                         ' Subroutine
  VIEW PRINT 25 TO 25
  COLOR 15
  CLS
  LOCATE 25, 35
  PRINT "Working...";
  RETURN

Oops:                                      ' ANY Error Terminates the program
  CLOSE
  LOCATE 24, 16, 0
  COLOR 15
  PRINT "*** ERROR: Hit Any Key to Exit This Program ***";
  WHILE INKEY$ = ""
  WEND
  VIEW PRINT
  COLOR 7, 0
  CLS
  SYSTEM

